#ifndef SFMT_PARAMS2281_H
#define SFMT_PARAMS2281_H

#define POS1    12
#define SL1    19
#define SL2    1
#define SR1    5
#define SR2    1
#define MSK1    0xbff7ffbfU
#define MSK2    0xfdfffffeU
#define MSK3    0xf7ffef7fU
#define MSK4    0xf2f7cbbfU
#define PARITY1    0x00000001U
#define PARITY2    0x00000000U
#define PARITY3    0x00000000U
#define PARITY4    0x41dfa600U


/* PARAMETERS FOR ALTIVEC */
#if defined(__APPLE__)    /* For OSX */
    #define ALTI_SL1    (vector unsigned int)(SL1, SL1, SL1, SL1)
    #define ALTI_SR1    (vector unsigned int)(SR1, SR1, SR1, SR1)
    #define ALTI_MSK    (vector unsigned int)(MSK1, MSK2, MSK3, MSK4)
    #define ALTI_MSK64 \
    (vector unsigned int)(MSK2, MSK1, MSK4, MSK3)
    #define ALTI_SL2_PERM \
    (vector unsigned char)(1,2,3,23,5,6,7,0,9,10,11,4,13,14,15,8)
    #define ALTI_SL2_PERM64 \
    (vector unsigned char)(1,2,3,4,5,6,7,31,9,10,11,12,13,14,15,0)
    #define ALTI_SR2_PERM \
    (vector unsigned char)(7,0,1,2,11,4,5,6,15,8,9,10,17,12,13,14)
    #define ALTI_SR2_PERM64 \
    (vector unsigned char)(15,0,1,2,3,4,5,6,17,8,9,10,11,12,13,14)
#else    /* For OTHER OSs(Linux?) */
    #define ALTI_SL1    {SL1, SL1, SL1, SL1}
    #define ALTI_SR1    {SR1, SR1, SR1, SR1}
    #define ALTI_MSK    {MSK1, MSK2, MSK3, MSK4}
    #define ALTI_MSK64    {MSK2, MSK1, MSK4, MSK3}
    #define ALTI_SL2_PERM    {1,2,3,23,5,6,7,0,9,10,11,4,13,14,15,8}
    #define ALTI_SL2_PERM64    {1,2,3,4,5,6,7,31,9,10,11,12,13,14,15,0}
    #define ALTI_SR2_PERM    {7,0,1,2,11,4,5,6,15,8,9,10,17,12,13,14}
    #define ALTI_SR2_PERM64    {15,0,1,2,3,4,5,6,17,8,9,10,11,12,13,14}
#endif    /* For OSX */
#define IDSTR    "SFMT-2281:12-19-1-5-1:bff7ffbf-fdfffffe-f7ffef7f-f2f7cbbf"

#endif /* SFMT_PARAMS2281_H */
